#include <intrins.h>
#include <stdio.h>
#include <string.h>

#include "mymath.h"
#include "myiodef.h"
#include "delay.h"
#include "led_seg.h"


#define NO_SHOW_FLAG 0xFF
#define SET_BIT7_MASK (0x80)
#define PORT_DOT_SHOW(x) ((x)&0x7F)
#define UPPER_7TH_BIT(x) ((x)|SET_BIT7_MASK)
#define LOWER_7TH_BIT(x) ((x)&(~SET_BIT7_MASK))
#define NUM_SHOW_DOT(num) UPPER_7TH_BIT(num)
#define IS_HAVE_DOT(num) (SET_BIT7_MASK == ((num) & SET_BIT7_MASK))	
#define NEGATIVE_SIGN_SUB 10


u8 code seg_table[11]={0xc0,0xf9,0xa4,0xB0,0x99,0x92,0x82,0xf8,0x80,0x90,0xBF/*Ǹ*/};
// 4bit λ 1 0 ΪǲСı־λ
// жλǷΪ1 
u8 seg_show[8] = {0,NO_SHOW_FLAG,NO_SHOW_FLAG,NO_SHOW_FLAG,NO_SHOW_FLAG,NO_SHOW_FLAG,NO_SHOW_FLAG,NO_SHOW_FLAG};

#ifdef USE_LEDSHOWBYNUM1
i8 show_num_str[12] = {0x00};
#endif
i32 show_num = 0x00;

// ʾַĳ С0 8
u8 show_num_len = 1;


void LedShow(void)
{
	static u8 i;
	BIT_SELECTION_PORT = 0x7F;
	for(i = 0; i < 8;i++)
	{
		// жǷҪʾ
		if(NO_SHOW_FLAG == seg_show[i])
		{
			SEG_SELECTION_PORT = 0xFF;
		}
		else
		{
			// һжǷС
			if(IS_HAVE_DOT(seg_show[i]))
			{
				SEG_SELECTION_PORT = PORT_DOT_SHOW(seg_table[LOWER_7TH_BIT(seg_show[i])]);
			}
			else
			{
				SEG_SELECTION_PORT = seg_table[seg_show[i]];
			}
			
			
		}
		
		Delay(200);
		// Ӱ һҪ
		SEG_SELECTION_PORT = 0xFF;
		BIT_SELECTION_PORT = _cror_(BIT_SELECTION_PORT,1);
	}
}
#ifdef USE_LEDSHOWBYNUM1
void LedShowByNum1(i32 want_show_num)
{
	if(show_num != want_show_num)
	{
		
		u8 i = 0;
		show_num = want_show_num;
		sprintf(show_num_str,"%ld",show_num);
		show_num_len = strlen(show_num_str);

		for(i = (show_num_len+1); i < 12; i++)
		{
			show_num_str[i] = '\0';
		}
//		if(show_num_len > 8)
//		{
//			show_num_len = 8;
//		}
		//ֹ
		show_num_len = (show_num_len > 8) ? 8 : show_num_len;
		
		for(i = show_num_len;i < 8; i++)
		{
			seg_show[i] = NO_SHOW_FLAG;
		}
		for(i = 0; i < show_num_len; i++)
		{
			if('-' == show_num_str[i])
			{
				seg_show[show_num_len-1-i] = NEGATIVE_SIGN_SUB;
			}
			else
			{
				seg_show[show_num_len-1-i] = show_num_str[i] - 0x30;
			}
			
		}
	}
	
	LedShow();
}
#endif


#ifdef USE_LEDSHOWBYNUM2
void LedShowByNum2(i32 want_show_num)
{
	if(show_num != want_show_num)
	{
		
		u8 i = 0;
		show_num = want_show_num;
		//ȡĳ
		show_num_len = 1;
		
		while((want_show_num / 10) != 0)
		{
			want_show_num /= 10;
			show_num_len++;
		}
		if(show_num < 0)
		{
			show_num = - show_num;
			show_num_len++;
		}	
		for (i = 0; i < 8 ; i++ )
		{
			
			if(i < show_num_len)
			{
				seg_show[i] = show_num %  mypow(10,(i+1)) / mypow(10,(i));
				if(i == (show_num_len-1))
				{
					//жǲǸ
					seg_show[i] = show_num %  mypow(10,(i+1)) / mypow(10,(i));
					if(0 == seg_show[i])
					{
						seg_show[i] = NEGATIVE_SIGN_SUB;
					}
				}
			}
			else
			{
				seg_show[i] = NO_SHOW_FLAG;
			}
			
		}
		for( i = 1; i < 8;i++)
		{
			if(NEGATIVE_SIGN_SUB == seg_show[i])
			{
				show_num = -show_num;
				break;
			}
		}
	}
	LedShow();
}
#endif



